SystemOrganization addCategory: #'AL-Cors-Core'!
SystemOrganization addCategory: #'AL-Cors-Utilities'!

ALHttpGenerator subclass: #ALCorsGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Cors-Utilities'!

!ALCorsGenerator methodsFor: 'initialize-release' stamp: 'cwp 2/10/2014 15:29'!
initialize
	prefix := '*al-cors'! !

!ALCorsGenerator methodsFor: 'initialize-release' stamp: 'cwp 2/10/2014 15:35'!
methodCategoryPrefix
	^ '*al-cors'! !

!ALCorsGenerator methodsFor: 'specs' stamp: 'cwp 2/10/2014 15:58'!
requestHeaders
	^ #(
		('Origin' #ALUrl)	
		('Access-Control-Request-Method')
		('Access-Control-Request-Headers' #ALStrings)
	)
! !

!ALCorsGenerator methodsFor: 'specs' stamp: 'cwp 2/10/2014 15:56'!
responseHeaders
	^ #(
		('Access-Control-Allow-Credentials' #Boolean)
		('Access-Control-Allow-Headers' #ALStrings)
		('Access-Control-Allow-Methods' #ALStrings)
		('Access-Control-Allow-Origin' #ALUrl)
		('Access-Control-Expose-Headers' #ALStrings)
		('Access-Control-Max-Age' #Integer)
	)
! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowCredentials
	^ self parseHeader: 'Access-Control-Allow-Credentials' as: Boolean! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowCredentials: aBoolean
	headers at: 'Access-Control-Allow-Credentials' put: aBoolean
! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowHeaders
	^ self parseHeader: 'Access-Control-Allow-Headers' as: ALStrings! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowHeaders: anALStrings
	headers at: 'Access-Control-Allow-Headers' put: anALStrings
! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowMethods
	^ self parseHeader: 'Access-Control-Allow-Methods' as: ALStrings! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowMethods: anALStrings
	headers at: 'Access-Control-Allow-Methods' put: anALStrings
! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowOrigin
	^ self parseHeader: 'Access-Control-Allow-Origin' as: ALUrl! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlAllowOrigin: anALUrl
	headers at: 'Access-Control-Allow-Origin' put: anALUrl
! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlExposeHeaders
	^ self parseHeader: 'Access-Control-Expose-Headers' as: ALStrings! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlExposeHeaders: anALStrings
	headers at: 'Access-Control-Expose-Headers' put: anALStrings
! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlMaxAge
	^ self parseHeader: 'Access-Control-Max-Age' as: Integer! !

!ALResponse methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlMaxAge: anInteger
	headers at: 'Access-Control-Max-Age' put: anInteger
! !

!ALResponse methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlAllowCredentials
	^ headers includesKey: 'Access-Control-Allow-Credentials'
! !

!ALResponse methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlAllowHeaders
	^ headers includesKey: 'Access-Control-Allow-Headers'
! !

!ALResponse methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlAllowMethods
	^ headers includesKey: 'Access-Control-Allow-Methods'
! !

!ALResponse methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlAllowOrigin
	^ headers includesKey: 'Access-Control-Allow-Origin'
! !

!ALResponse methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlExposeHeaders
	^ headers includesKey: 'Access-Control-Expose-Headers'
! !

!ALResponse methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlMaxAge
	^ headers includesKey: 'Access-Control-Max-Age'
! !

!ALRequest methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlRequestHeaders
	^ self parseHeader: 'Access-Control-Request-Headers' as: ALStrings! !

!ALRequest methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlRequestHeaders: anALStrings
	headers at: 'Access-Control-Request-Headers' put: anALStrings
! !

!ALRequest methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlRequestMethod
	^ self parseHeader: 'Access-Control-Request-Method' as: String! !

!ALRequest methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
accessControlRequestMethod: aString
	headers at: 'Access-Control-Request-Method' put: aString
! !

!ALRequest methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlRequestHeaders
	^ headers includesKey: 'Access-Control-Request-Headers'
! !

!ALRequest methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasAccessControlRequestMethod
	^ headers includesKey: 'Access-Control-Request-Method'
! !

!ALRequest methodsFor: '*al-cors-headers-testing' stamp: 'cwp 2/10/2014 15:58'!
hasOrigin
	^ headers includesKey: 'Origin'
! !

!ALRequest methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
origin
	^ self parseHeader: 'Origin' as: ALUrl! !

!ALRequest methodsFor: '*al-cors-headers-accessing' stamp: 'cwp 2/10/2014 15:58'!
origin: anALUrl
	headers at: 'Origin' put: anALUrl
! !

ALRelay subclass: #ALCorsRelay
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AL-Cors-Core'!

!ALCorsRelay class methodsFor: 'as yet unclassified' stamp: 'cwp 2/10/2014 14:21'!
destination: aRelay origin: aUrl
	^ self basicNew initializeWithDestination: aRelay origin: aUrl! !

!ALCorsRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/25/2014 14:36'!
handleRequest: aRequest
	| response |
	response := destination handleRequest: aRequest.
	aRequest origin = origin ifTrue:
		[response accessControlAllowOrigin: aRequest origin].
	(response status >= 300 and: [response status <=399]) ifTrue:
		[response accessControlAllowMethods: (ALStrings with: 'GET')].
	(aRequest hasAccessControlRequestHeaders) 
		ifTrue:
			[response accessControlAllowHeaders: aRequest accessControlRequestHeaders].
	^ response! !

!ALCorsRelay methodsFor: 'as yet unclassified' stamp: 'cwp 2/10/2014 14:21'!
initializeWithDestination: aRelay origin: aUrl
	self initializeWithDestination: aRelay.
	origin := aUrl! !
